# frozen_string_literal: true

class Flux13SideEffectsJob < ActiveJob::Base
  queue_as :flux_13_side_effects

  def perform(housing_offer_id)
    # Get all active application for given offer
    o = Hermes::HousingOffer.find(housing_offer_id)
    applications = Hermes::HousingApplication.where(is_active: true, housing_offer_id: housing_offer_id)

    ha_status = 
      if ['RETIRE PAR LE BAILLEUR', 'RETIRE PAR ALS'].include?(o.offer_status) && o.lessor_status == 'RETIRE'
        'REPRIS BAILLEUR'
      elsif o.offer_status == 'ARCHIVE' && o.lessor_status == 'RETIRE'
        'NON RETENUE'
      elsif o.offer_status == 'RENDU AU BAILLEUR' && o.lessor_status == 'RENDU AU BAILLEUR CONFIRME'
        'ANNULEE BAILLEUR'
      else
        nil
      end 

    return unless ha_status
    
    applications.batch_size(5).each do |application|
      # Update status and disable application
      application.update!(status: ha_status)
      # Notify applicant
      # application.notify(
      #   key: NOTIFICATION_KEYS[:housing_application][:lessor_withdrawal],
      #   channels: ['email'],
      #   datas: { number: application.housing_offer.reference }
      # )
    end
  end
end